import savePixels from 'save-pixels';
import ndarray from 'ndarray';
import { bufferToArrayBuffer } from "../buffer/to-array-buffer.node.js";
export function encodeImageToStreamNode(image, options) {
  const type = options.type ? options.type.replace('image/', '') : 'jpeg';
  const pixels = ndarray(image.data, [image.width, image.height, 4], [4, image.width * 4, 1], 0);
  return savePixels(pixels, type, options);
}
export function encodeImageNode(image, options) {
  const imageStream = encodeImageToStreamNode(image, options);
  return new Promise(resolve => {
    const buffers = [];
    imageStream.on('data', buffer => buffers.push(buffer));
    imageStream.on('end', () => {
      const buffer = Buffer.concat(buffers);
      resolve(bufferToArrayBuffer(buffer));
    });
  });
}
//# sourceMappingURL=encode-image.node.js.map